﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Windows.Forms;
using Infragistics.Win.UltraWinChart;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Create the sample data
            DataTable table = new DataTable();
            table.Columns.Add("Data", typeof(List<double>));
            table.Columns.Add("ID");
            table.Columns.Add("Type");

            table.Rows.Add(new object[] { new List<double> { 10, 5, 5 }, Guid.NewGuid().ToString(), "SELECT" });
            table.Rows.Add(new object[] { new List<double> { 10, 20, 10 }, Guid.NewGuid().ToString(), "SELECT" });
            table.Rows.Add(new object[] { new List<double> { 40, 10, 10 }, Guid.NewGuid().ToString(), "UNKNOWN" });
            table.Rows.Add(new object[] { new List<double> { 60, 0, 0 }, Guid.NewGuid().ToString(), "UNKNOWN" });
            table.Rows.Add(new object[] { new List<double> { 50, 0, 15 }, Guid.NewGuid().ToString(), "UNKNOWN" });

            this.ultraGrid1.DataSource = table;

            this.ultraGrid1.DisplayLayout.Override.DefaultRowHeight = 200;
            this.ultraGrid1.DisplayLayout.Override.DefaultColWidth = 300;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            // Add an unbound column to display the graph.
            var activityColumn = e.Layout.Bands[0].Columns.Insert(0, "Activity");
            activityColumn.CellActivation = Activation.Disabled;
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (e.Row.Cells.Exists("Data"))
            {
                List<double> data = e.Row.GetCellValue("Data") as List<double>;

                UltraChart chart = new UltraChart();
                chart.Data.ZeroAligned = true;
                chart.Name = "chart";
                chart.Height = 200;
                chart.Width = 300;
                chart.DataSource = data;
                chart.DataBind();

                e.Row.Cells["Activity"].Appearance.ImageBackground = chart.Image;
            }
        }
    }
}
